"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_redux_1 = require("react-redux");
var hoistNonReactStatic = require("hoist-non-react-statics");
var invariant = require("invariant");
var Provider_1 = require("./Provider");
function createConnect() {
    return function (mapStateToProps, mapDispatchToProps, mergeProps, extraOptions) {
        if (mergeProps === void 0) { mergeProps = null; }
        if (extraOptions === void 0) { extraOptions = {}; }
        var _a;
        var storeKey = 'store';
        var resaKey = storeKey + "Resa";
        var subscriptionKey = storeKey + "Subscription";
        var contextTypes = (_a = {},
            _a[storeKey] = Provider_1.storeShape.isRequired,
            _a[subscriptionKey] = Provider_1.subscriptionShape,
            _a[resaKey] = Provider_1.resaShape.isRequired,
            _a);
        return function wrapWithConnect(WrappedComponent) {
            var Connect = (function (_super) {
                __extends(Connect, _super);
                function Connect(props, context) {
                    var _this = _super.call(this, props, context) || this;
                    _this.resa = props.theme[resaKey];
                    _this.wrappedInstance = null;
                    _this.setWappedInstance = _this.setWappedInstance.bind(_this);
                    var newMapStateToProps = (function () {
                        if (mapStateToProps == null) {
                            return null;
                        }
                        return function (state, ownProps) { return mapStateToProps(_this.resa.models, state, ownProps); };
                    })();
                    var newMapDispatchToProps = (function () {
                        if (mapDispatchToProps == null) {
                            return null;
                        }
                        if (Array.isArray(mapDispatchToProps)) {
                            var models_1 = {};
                            mapDispatchToProps.forEach(function (namespace) {
                                var model = _this.resa.models[namespace];
                                models_1[namespace] = model;
                            });
                            return function () { return models_1; };
                        }
                        return function (dispatch) { return mapDispatchToProps(_this.resa.models, dispatch); };
                    })();
                    var reduxExtraOptions = {
                        withRef: extraOptions.forwardRef || false,
                    };
                    _this.ConnectedComponent = react_redux_1.connect(newMapStateToProps, newMapDispatchToProps, mergeProps, reduxExtraOptions)(WrappedComponent);
                    return _this;
                }
                Connect.prototype.getChildContext = function () {
                    var _a;
                    return _a = {},
                        _a[storeKey] = this.context[storeKey],
                        _a[subscriptionKey] = this.context[subscriptionKey],
                        _a[resaKey] = this.context[resaKey],
                        _a;
                };
                Connect.prototype.setWappedInstance = function (ref) {
                    var forwardedRef = this.props.forwardedRef;
                    if (forwardedRef == null) {
                        return;
                    }
                    invariant(forwardedRef.hasOwnProperty('current'), 'You must use React.createRef() to create ref.');
                    if (ref == null) {
                        forwardedRef.current = null;
                        return;
                    }
                    if (forwardedRef) {
                        forwardedRef.current = ref.getWrappedInstance();
                    }
                };
                Connect.prototype.render = function () {
                    var ConnectedComponent = this.ConnectedComponent;
                    return React.createElement(ConnectedComponent, __assign({}, this.props, { ref: this.setWappedInstance }));
                };
                return Connect;
            }(React.Component));
            Connect.WrappedComponent = WrappedComponent;
            var wrappedComponentName = WrappedComponent.displayName || WrappedComponent.name || 'Component';
            Connect.displayName = "ResaConnect(" + wrappedComponentName + ")";
            Connect.childContextTypes = contextTypes;
            Connect.contextTypes = contextTypes;
            var TargetComponent = hoistNonReactStatic(Connect, WrappedComponent);
            if (extraOptions.forwardRef) {
                return React.forwardRef(function (props, ref) { return (React.createElement(Provider_1.ThemeContext.Consumer, null, function (theme) { return React.createElement(TargetComponent, __assign({}, props, { forwardedRef: ref, theme: theme })); })); });
            }
            return function (props) { return (React.createElement(Provider_1.ThemeContext.Consumer, null, function (theme) { return React.createElement(TargetComponent, __assign({}, props, { theme: theme })); })); };
        };
    };
}
exports.default = createConnect;
