"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var TestUtils = require("react-dom/test-utils");
var resa_1 = require("resa");
var decoratorChild_1 = require("./decoratorChild");
var model = {
    name: 'model',
    state: {},
    effects: {
        add: function (payload) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.fulfilled(payload);
                        return [4, 1];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
        minus: function (payload) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.reject(payload);
                        return [4, 1];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
    },
};
var model1 = {
    name: 'model1',
    state: {},
    effects: {
        add: function (payload) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.fulfilled(payload);
                        return [4, 1];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
        minus: function (payload) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.reject(payload);
                        return [4, 1];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
    },
};
var Child = (function (_super) {
    __extends(Child, _super);
    function Child() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Child.prototype.render = function () {
        return React.createElement("div", null);
    };
    return Child;
}(React.Component));
describe('Connect', function () {
    test('should pass state and props to the given component', function () {
        var app = resa_1.default();
        var mapStateToProps = function (_app, _state) { return ({
            a: 'a',
        }); };
        var func = function () { };
        var mapDispatchToProps = function (_app, _dispatch) { return ({
            func: func,
        }); };
        var ConnectedChild = resa_1.connect(mapStateToProps, mapDispatchToProps)(Child);
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, null)));
        var container = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(container.props.a).toEqual('a');
        expect(container.props.func).toEqual(func);
    });
    test('mapStateToProps can get app and state', function () {
        var app = resa_1.default();
        app.registerModel(model, 'model');
        app.models.model.add({ a: 'a' });
        var mapStateToProps = function (_a, state, ownProps) {
            var model = _a.model;
            return ({
                a: state.model.a,
                ownProps: ownProps,
            });
        };
        var ConnectedChild = resa_1.connect(mapStateToProps)(Child);
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, { c: 'c' })));
        var container = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(container.props.a).toEqual('a');
        expect(container.props.ownProps).toEqual({ c: 'c', theme: expect.anything() });
    });
    test('mapDispatchToProps can get models and dispatch', function () {
        var app = resa_1.default();
        var mapDispatchToProps = function (models, dispatch) { return ({
            func: function () { return ({
                models: models,
                dispatch: dispatch,
            }); },
        }); };
        var ConnectedChild = resa_1.connect(null, mapDispatchToProps)(Child);
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, null)));
        var container = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(container.props.func()).toEqual({
            models: app.models,
            dispatch: app.store.dispatch,
        });
    });
    test('get wapperInstance using React.createRef()', function () {
        var app = resa_1.default();
        var ConnectedChild = resa_1.connect(null, null, null, { forwardRef: true })(Child);
        var ref = React.createRef();
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, { ref: ref, c: 'c' })));
        var child = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(ref.current).toEqual(child);
    });
    test('should use React.createRef()', function () {
        var app = resa_1.default();
        var ConnectedChild = resa_1.connect(null, null, null, { forwardRef: true })(Child);
        var ref = function () { };
        expect(function () {
            TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
                React.createElement(ConnectedChild, { ref: ref })));
        }).toThrow('You must use React.createRef() to create ref.');
    });
    test('mapDispatchToProps can bind app name and get model in mapdispathtoprops', function () {
        var app = resa_1.default();
        app.registerModel(model, 'model');
        app.registerModel(model1, 'model1');
        var mapDispatchToProps = function (_a, dispatch) {
            var model = _a.model, model1 = _a.model1;
            return ({
                func: function () { return ({
                    dispatch: dispatch,
                    model: model,
                    model1: model1,
                }); },
            });
        };
        var ConnectedChild = resa_1.connect(null, mapDispatchToProps)(Child, 'model', 'model1');
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, null)));
        var container = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(container.props.func()).toEqual({
            dispatch: app.store.dispatch,
            model: app.models.model,
            model1: app.models.model1,
        });
    });
});
describe('connectModel', function () {
    test('conncet model success', function () {
        var app = resa_1.default();
        app.registerModel(model, 'model1');
        var mapStateToProps = function (_app, _state) { return ({
            a: 'a',
        }); };
        var ConnectedChild = resa_1.connect(mapStateToProps, ['model'])(Child);
        var tree = TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(ConnectedChild, null)));
        var container = TestUtils.findRenderedComponentWithType(tree, Child);
        expect(container.props.a).toEqual('a');
        expect(container.props.model.name).toEqual('model');
    });
    test('conncet model decorator success', function () {
        var app = resa_1.default();
        app.registerModel(model, 'model1');
        var ref = React.createRef();
        var DecoratorChildAny = decoratorChild_1.default;
        TestUtils.renderIntoDocument(React.createElement(resa_1.Provider, { store: app.store, resa: app },
            React.createElement(DecoratorChildAny, { ref: ref })));
        expect(ref.current.props.a).toEqual('a');
        expect(ref.current.props.model.name).toEqual('model');
    });
});
