"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var warning = require("warning");
exports.subscriptionShape = PropTypes.shape({
    trySubscribe: PropTypes.func.isRequired,
    tryUnsubscribe: PropTypes.func.isRequired,
    notifyNestedSubs: PropTypes.func.isRequired,
    isSubscribed: PropTypes.func.isRequired,
});
exports.storeShape = PropTypes.shape({
    subscribe: PropTypes.func.isRequired,
    dispatch: PropTypes.func.isRequired,
    getState: PropTypes.func.isRequired,
});
exports.resaShape = PropTypes.shape({
    store: PropTypes.object.isRequired,
    runSaga: PropTypes.func.isRequired,
    models: PropTypes.object.isRequired,
    registerModel: PropTypes.func.isRequired,
});
var didWarnAboutReceivingStore = false;
function warnAboutReceivingStore() {
    if (didWarnAboutReceivingStore) {
        return;
    }
    didWarnAboutReceivingStore = true;
    warning('<Provider> does not support changing `store` on the fly. ' +
        'It is most likely that you see this error because you updated to ' +
        'Redux 2.x and React Redux 2.x which no longer hot reload reducers ' +
        'automatically. See https://github.com/reactjs/react-redux/releases/' +
        'tag/v2.0.0 for the migration instructions.');
}
exports.ThemeContext = React.createContext({});
function createProvider(storeKey, subKey) {
    if (storeKey === void 0) { storeKey = 'store'; }
    if (subKey === void 0) { subKey = undefined; }
    var _a;
    var resaKey = storeKey + "Resa";
    var subscriptionKey = subKey || storeKey + "Subscription";
    var Provider = (function (_super) {
        __extends(Provider, _super);
        function Provider(props, context) {
            var _a;
            var _this = _super.call(this, props, context) || this;
            _this[storeKey] = props.resa.store;
            _this[resaKey] = props.resa;
            _this.theme = (_a = {},
                _a[storeKey] = _this[storeKey],
                _a[subscriptionKey] = null,
                _a[resaKey] = _this[resaKey],
                _a.storeKey = storeKey,
                _a);
            return _this;
        }
        Provider.prototype.getChildContext = function () {
            var _a;
            return _a = {},
                _a[storeKey] = this[storeKey],
                _a[subscriptionKey] = null,
                _a[resaKey] = this[resaKey],
                _a;
        };
        Provider.prototype.render = function () {
            return (React.createElement(exports.ThemeContext.Provider, { value: this.theme }, React.Children.only(this.props.children)));
        };
        return Provider;
    }(React.Component));
    if (process.env.NODE_ENV !== 'production') {
        Provider.prototype.componentWillReceiveProps = function (nextProps) {
            if (this[storeKey] !== nextProps.resa.store) {
                warnAboutReceivingStore();
            }
        };
    }
    Provider.propTypes = {
        children: PropTypes.element.isRequired,
        resa: exports.resaShape.isRequired,
    };
    Provider.childContextTypes = (_a = {},
        _a[storeKey] = exports.storeShape.isRequired,
        _a[subscriptionKey] = exports.subscriptionShape,
        _a[resaKey] = exports.resaShape.isRequired,
        _a);
    return Provider;
}
exports.createProvider = createProvider;
exports.default = createProvider();
