"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var hoistNonReactStatic = require("hoist-non-react-statics");
var Provider_1 = require("./Provider");
var Subscription_1 = require("react-redux/lib/utils/Subscription");
var createObservable_1 = require("../utils/createObservable");
var invariant = require("invariant");
function checkModelType(model, name, modelTypeName) {
    var instanceCon = modelTypeName[name];
    if (instanceCon == null) {
        modelTypeName[name] = model.constructor;
    }
    else {
        invariant(instanceCon === model.constructor, "Different Model should not use the same model name, Please check name: " + name);
    }
}
function subscribe(modelMap, dependences, extraOptions) {
    if (dependences === void 0) { dependences = []; }
    if (extraOptions === void 0) { extraOptions = {}; }
    return function wrapWithSubscribe(WrappedComponent) {
        var Subscribe = (function (_super) {
            __extends(Subscribe, _super);
            function Subscribe(props) {
                var _a;
                var _this = _super.call(this, props) || this;
                _this.tryRegister = function () {
                    var models = _this.resa.models;
                    Object.keys(modelMap).map(function (key) {
                        var modelItem = modelMap[key];
                        var instance = new modelItem();
                        var namespace = instance.namespace;
                        var name = namespace === '' ? instance.name : namespace + "/" + instance.name;
                        var model = models[name];
                        if (process.env.NODE_ENV !== 'production') {
                            checkModelType(instance, name, _this.resa.modelTypeName);
                            invariant(Object.prototype.toString.call(instance.state) === '[object Object]', 'The shape of state must be an object');
                        }
                        if (model == null) {
                            _this.resa.register(instance);
                        }
                        var depandenceMap = {};
                        dependences.map(function (dp) {
                            depandenceMap[dp] = true;
                        });
                        _this.modelMetaMap[key] = {
                            name: name,
                            depandenceMap: depandenceMap,
                            observableModel: null,
                            state: null,
                        };
                    });
                };
                _this.updateObservable = function () {
                    var models = _this.resa.models;
                    Object.keys(_this.modelMetaMap).map(function (key) {
                        var modelMeta = _this.modelMetaMap[key];
                        var model = models[modelMeta.name];
                        var state = model.state;
                        if (modelMeta.state !== state) {
                            modelMeta.state = state;
                            modelMeta.observableModel = Object.assign({}, model, {
                                state: createObservable_1.default(state, modelMeta.depandenceMap),
                            });
                        }
                    });
                };
                _this.calculateShouldUpdate = function () {
                    var models = _this.resa.models;
                    return Object.keys(_this.modelMetaMap).some(function (key) {
                        var modelMeta = _this.modelMetaMap[key];
                        var model = models[modelMeta.name];
                        var state = model.state;
                        var prevState = modelMeta.state;
                        var dMap = modelMeta.depandenceMap;
                        return Object.keys(dMap).some(function (key) {
                            if (state[key] !== prevState[key]) {
                                return true;
                            }
                            return false;
                        });
                    });
                };
                _this.onStateChange = function () {
                    var shouldUpdate = _this.calculateShouldUpdate();
                    if (shouldUpdate) {
                        _this.componentDidUpdate = _this.notifyNestedSubsOnComponentDidUpdate;
                        _this.updateObservable();
                        _this.forceUpdate();
                    }
                    else {
                        _this.notifyNestedSubs();
                    }
                };
                _this.getModels = function () {
                    var returnMap = {};
                    Object.keys(_this.modelMetaMap).map(function (key) {
                        returnMap[key] = _this.modelMetaMap[key].observableModel;
                    });
                    return returnMap;
                };
                _this.storeKey = props.theme.storeKey;
                _this.resaKey = _this.storeKey + "Resa";
                _this.subscriptionKey = _this.storeKey + "Subscription";
                _this.resa = props.theme[_this.resaKey];
                _this.modelMetaMap = {};
                _this.tryRegister();
                _this.updateObservable();
                _this.initSubscription();
                _this.theme = (_a = {},
                    _a[_this.storeKey] = _this.resa.store,
                    _a[_this.subscriptionKey] = _this.subscription,
                    _a[_this.resaKey] = _this.resa,
                    _a.storeKey = _this.props.theme.storeKey,
                    _a);
                return _this;
            }
            Subscribe.prototype.initSubscription = function () {
                var parentSub = this.props.theme[this.subscriptionKey];
                this.subscription = new Subscription_1.default(this.resa.store, parentSub, this.onStateChange.bind(this));
                this.notifyNestedSubs = this.subscription.notifyNestedSubs.bind(this.subscription);
            };
            Subscribe.prototype.componentDidMount = function () {
                this.subscription.trySubscribe();
            };
            Subscribe.prototype.componentWillUnmount = function () {
                if (this.subscription)
                    this.subscription.tryUnsubscribe();
                this.subscription = null;
                this.notifyNestedSubs = function () { };
            };
            Subscribe.prototype.notifyNestedSubsOnComponentDidUpdate = function () {
                this.componentDidUpdate = undefined;
                this.notifyNestedSubs();
            };
            Subscribe.prototype.render = function () {
                var _a = this.props, theme = _a.theme, forwardedRef = _a.forwardedRef, rest = __rest(_a, ["theme", "forwardedRef"]);
                return (React.createElement(Provider_1.ThemeContext.Provider, { value: this.theme },
                    React.createElement(WrappedComponent, __assign({ ref: forwardedRef }, rest, this.getModels()))));
            };
            return Subscribe;
        }(React.PureComponent));
        Subscribe.WrappedComponent = WrappedComponent;
        var wrappedComponentName = WrappedComponent.displayName || WrappedComponent.name || 'Component';
        Subscribe.displayName = "ResaSubscribe(" + wrappedComponentName + ")";
        var TargetComponent = hoistNonReactStatic(Subscribe, WrappedComponent);
        if (extraOptions.forwardRef) {
            return React.forwardRef(function (props, ref) { return (React.createElement(Provider_1.ThemeContext.Consumer, null, function (theme) { return React.createElement(TargetComponent, __assign({}, props, { forwardedRef: ref, theme: theme })); })); });
        }
        return function (props) { return (React.createElement(Provider_1.ThemeContext.Consumer, null, function (theme) { return React.createElement(TargetComponent, __assign({}, props, { theme: theme })); })); };
    };
}
exports.default = subscribe;
