"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Immutable = require("immutable");
var resa_1 = require("resa");
var model1 = {
    name: 'model1',
    state: {
        count: 0,
    },
    effects: {
        add: function (count) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.fulfilled({
                            count: this.state.count + count,
                        });
                        return [4, 0];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
    },
};
var model2 = {
    name: 'model2',
    state: {
        count: 0,
    },
    effects: {
        add: function (count) {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.fulfilled({
                            count: this.state.count + count + count,
                        });
                        return [4, 0];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        },
    },
};
var combinedModel = resa_1.combineModel('xxx', [model1, model2]);
describe('combineModel', function () {
    test('combinemodel resiger success', function () {
        var app = resa_1.default();
        app.registerModel(combinedModel);
        expect(app.store.getState()).toEqual({
            xxx: {
                model1: { count: 0 },
                model2: { count: 0 },
            },
            resaReducer: {},
        });
    });
    test('combinemodel dispatch action success', function () {
        var app = resa_1.default();
        app.registerModel(combinedModel);
        app.models.model1.add(1);
        app.models.model2.add(2);
        return new Promise(function (resolve) {
            setTimeout(function () {
                resolve(app.store.getState());
            }, 5);
        }).then(function (data) {
            expect(data).toEqual({
                resaReducer: {},
                xxx: {
                    model1: { count: 1 },
                    model2: { count: 4 },
                },
            });
        });
    });
    test('immutable root', function () {
        var app = resa_1.default({ initialState: Immutable.Map() });
        app.registerModel(combinedModel);
        app.models.model1.add(1);
        app.models.model2.add(2);
        return new Promise(function (resolve) {
            setTimeout(function () {
                resolve(app.store.getState());
            }, 5);
        }).then(function (data) {
            expect(data).toEqual(Immutable.Map({
                resaReducer: {},
                xxx: {
                    model1: { count: 1 },
                    model2: { count: 4 },
                },
            }));
        });
    });
    test('avoid resigter top level combined model twice', function () {
        expect(function () {
            var app = resa_1.default();
            app.registerModel(combinedModel);
            app.registerModel(combinedModel);
        }).toThrow(/name of model should be unique, please check model name:/);
    });
    test('unRegisterModel combined model success', function () {
        var app = resa_1.default();
        app.registerModel(combinedModel);
        app.unRegisterModel(combinedModel);
        expect(app.models).toEqual({});
    });
    test('should only unRegister root model', function () {
        expect(function () {
            var app = resa_1.default();
            app.registerModel(combinedModel);
            app.unRegisterModel(model1);
        }).toThrow(/should only unRegister root model/);
    });
});
