"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var createObservableProperty = function createObservableProperty(target, property, value, depandenceMap) {
    Object.defineProperty(target, property, {
        get: function get() {
            depandenceMap[property] = true;
            return value;
        },
    });
};
var createObservable = function createObservable(target, depandenceMap) {
    var newTarget = {};
    for (var key in target) {
        if (target.hasOwnProperty(key)) {
            createObservableProperty(newTarget, key, target[key], depandenceMap);
        }
    }
    return newTarget;
};
exports.default = createObservable;
